import { HttpClient } from './HttpClient';
import { THETA_CALL_SMART_CONTRACT_INTERFACE, THETA_EENP_INTERFACE, THETA_GCP_INTERFACE, THETA_GET_ACCOUNT_INTERFACE, THETA_GET_BLOCK_INTERFACE, THETA_GET_PENDING_TRANSACTIONS_INTERFACE, THETA_GET_STAKE_REWARD_DISTRIBUTION_BY_HEIGHT_INTERFACE, THETA_GET_VERSION_INTERFACE, THETA_NODE_STATUS, THETA_TRANSACTION_INTERFACE, THETA_VCP_INTERFACE } from '../types/interface';
export declare class ThetaHttpProvider {
    httpClient: HttpClient;
    constructor();
    setUrl(url: string): void;
    getBlockByHeight(blockHeight: string): Promise<THETA_GET_BLOCK_INTERFACE>;
    getVcpByHeight(blockHeight: string): Promise<THETA_VCP_INTERFACE>;
    getGcpByHeight(blockHeight: string): Promise<THETA_GCP_INTERFACE>;
    getEenpByHeight(blockHeight: string): Promise<THETA_EENP_INTERFACE>;
    getStatus(): Promise<THETA_NODE_STATUS>;
    getVersion(): Promise<THETA_GET_VERSION_INTERFACE>;
    getAccount(address: string): Promise<THETA_GET_ACCOUNT_INTERFACE>;
    getBlock(hash: string): Promise<THETA_GET_BLOCK_INTERFACE>;
    getBlockSByRange(start: string, end: string, includeEthTxHashes?: boolean): Promise<THETA_GET_BLOCK_INTERFACE>;
    getTransaction(hash: string): Promise<THETA_TRANSACTION_INTERFACE>;
    getPendingTransactions(): Promise<THETA_GET_PENDING_TRANSACTIONS_INTERFACE>;
    getStakeRewardDistributionByHeight(blockHeight: string): Promise<THETA_GET_STAKE_REWARD_DISTRIBUTION_BY_HEIGHT_INTERFACE>;
    callSmartContract(from: string, to: string, data: string): Promise<THETA_CALL_SMART_CONTRACT_INTERFACE>;
}
